    using System;
    using System.Collections.Generic;
    using System.Text;
    using System.Reflection;
    using System.IO;

    using VB = Microsoft.VisualBasic;

    using AcadApp = Autodesk.AutoCAD.ApplicationServices.Application;
    using AcadInt = Autodesk.AutoCAD.Interop;
    using AcadIntCommon = Autodesk.AutoCAD.Interop.Common;

    namespace Autocad2007Plugin
    {
        static class MenuSupport
        {
            static public void RegisterToolBar(string toolbarName)
            {
                AcadInt.AcadApplication  AcadAppInt =  (AcadInt.AcadApplication) AcadApp.AcadApplication ;
                AcadInt.AcadMenuGroup mnuGrp = null;
                VB.ApplicationServices.AssemblyInfo Info= new VB.ApplicationServices.AssemblyInfo(System.Reflection.Assembly.GetExecutingAssembly() );
                String PathToIcons = Path.Combine(Info.DirectoryPath, "Icons");
                foreach (AcadInt.AcadMenuGroup mnu in AcadAppInt.MenuGroups) 
                {
                    if (mnu.Name.ToLower() == "custom")
                    {
                        mnuGrp = mnu;
                        break;
                    }
                }

                if (mnuGrp != null)
                {
                    AcadInt.AcadToolbar toolBar = null;
                    foreach (AcadInt.AcadToolbar tlb in mnuGrp.Toolbars)
                    {
                        if (tlb.Name.ToLower() == toolbarName)
                        {
                            toolBar = tlb;
                            break;
                        }
                    }
                    if (toolBar == null)
                    {
                        toolBar = mnuGrp.Toolbars.Add(toolbarName);
                    }

                    AcadInt.AcadToolbarItem tbItem = null;
                    tbItem = toolBar.AddToolbarButton(toolBar.Count + 1, 
                                                    "Log In", "",
                                                    FormatCommand("MYLOGIN"), 
                                                    Missing.Value);
                    if (tbItem != null)
                    {
                        try
                        {

                            tbItem.SetBitmaps(
                               Path.Combine(PathToIcons,"login.ico"),
                               Path.Combine(PathToIcons, "login.ico")
                                              );
                        }
                        catch (Exception e) 
                        {
                        }
                    }
                    tbItem = null;

                    tbItem = toolBar.AddToolbarButton(toolBar.Count + 1,
                                                    "Log Out", "",
                                                    FormatCommand("MYLOGOUT"),
                                                    Missing.Value);
                    if (tbItem != null)
                    {
                        try
                        {
                            tbItem.SetBitmaps(
                               Path.Combine(PathToIcons, "logout.ico"),
                               Path.Combine(PathToIcons, "logout.ico")
                                              );
                        }
                        catch (Exception e)
                        {
                        }
                    }
                    toolBar.Dock(AcadIntCommon.AcToolbarDockStatus.acToolbarDockTop);
                }
            }

            static private string FormatCommand(string cmdName)
            {
                StringBuilder cmd = new StringBuilder();
                cmd.Append(VB.Strings.Chr(3));
                cmd.Append(VB.Strings.Chr(3));
                cmd.Append(VB.Strings.Chr(95));
                cmd.Append(cmdName);
                cmd.Append(VB.Strings.Chr(32));
                return cmd.ToString();
            }
        }
    }
